/* Generated automatically by the program `genextract'
   from the machine description file `md'.  */

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "tm.h"
#include "rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "diagnostic-core.h"

/* This variable is used as the "location" of any missing operand
   whose numbers are skipped by a given pattern.  */
static rtx junk ATTRIBUTE_UNUSED;

void
insn_extract (rtx insn)
{
  rtx *ro = recog_data.operand;
  rtx **ro_loc = recog_data.operand_loc;
  rtx pat = PATTERN (insn);
  int i ATTRIBUTE_UNUSED; /* only for peepholes */

#ifdef ENABLE_CHECKING
  memset (ro, 0xab, sizeof (*ro) * MAX_RECOG_OPERANDS);
  memset (ro_loc, 0xab, sizeof (*ro_loc) * MAX_RECOG_OPERANDS);
#endif

  switch (INSN_CODE (insn))
    {
    default:
      /* Control reaches here if insn_extract has been called with an
         unrecognizable insn (code -1), or an insn whose INSN_CODE
         corresponds to a DEFINE_EXPAND in the machine description;
         either way, a bug.  */
      if (INSN_CODE (insn) < 0)
        fatal_insn ("unrecognizable insn:", insn);
      else
        fatal_insn ("insn with invalid code number:", insn);

    case 626:
    case 625:
    case 624:
    case 623:
      for (i = XVECLEN (pat, 0) - 1; i >= 0; i--)
          ro[i] = *(ro_loc[i] = &XVECEXP (pat, 0, i));
      break;

    case 465:  /* stack_tie */
      ro[0] = *(ro_loc[0] = &XVECEXP (XEXP (pat, 1), 0, 0));
      ro[1] = *(ro_loc[1] = &XVECEXP (XEXP (pat, 1), 0, 1));
      break;

    case 462:  /* cosxf2 */
    case 461:  /* cosdf2 */
    case 460:  /* cossf2 */
    case 459:  /* sinxf2 */
    case 458:  /* sindf2 */
    case 457:  /* sinsf2 */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XVECEXP (XEXP (pat, 1), 0, 0));
      break;

    case 451:  /* indirect_jump */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 1));
      break;

    case 449:  /* *unlink */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 0), 0));
      recog_data.dup_loc[0] = &XEXP (XEXP (XVECEXP (pat, 0, 1), 1), 0);
      recog_data.dup_num[0] = 0;
      recog_data.dup_loc[1] = &XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0);
      recog_data.dup_num[1] = 0;
      break;

    case 448:  /* *link */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XVECEXP (pat, 0, 2), 1), 1));
      recog_data.dup_loc[0] = &XEXP (XVECEXP (pat, 0, 1), 1);
      recog_data.dup_num[0] = 0;
      break;

    case 447:  /* *m68k_load_multiple_automod */
    case 445:  /* *m68k_store_multiple_automod */
      ro[0] = *(ro_loc[0] = &PATTERN (insn));
      ro[1] = *(ro_loc[1] = &XEXP (XVECEXP (pat, 0, 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0));
      ro[3] = *(ro_loc[3] = &XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 1));
      break;

    case 446:  /* *m68k_load_multiple */
    case 444:  /* *m68k_store_multiple */
      ro[0] = *(ro_loc[0] = &PATTERN (insn));
      ro[1] = *(ro_loc[1] = &XVECEXP (pat, 0, 0));
      break;

    case 466:  /* ib */
    case 463:  /* trap */
    case 443:  /* *return */
    case 442:  /* nop */
    case 441:  /* blockage */
      break;

    case 434:  /* *dbge_si */
    case 433:  /* *dbge_hi */
      ro[0] = *(ro_loc[0] = &XEXP (XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0), 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 1), 0));
      recog_data.dup_loc[0] = &XEXP (XVECEXP (pat, 0, 1), 0);
      recog_data.dup_num[0] = 0;
      recog_data.dup_loc[1] = &XEXP (XEXP (XVECEXP (pat, 0, 1), 1), 0);
      recog_data.dup_num[1] = 0;
      break;

    case 432:  /* *dbne_si */
    case 431:  /* *dbne_hi */
      ro[0] = *(ro_loc[0] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 1), 0));
      recog_data.dup_loc[0] = &XEXP (XVECEXP (pat, 0, 1), 0);
      recog_data.dup_num[0] = 0;
      recog_data.dup_loc[1] = &XEXP (XEXP (XVECEXP (pat, 0, 1), 1), 0);
      recog_data.dup_num[1] = 0;
      break;

    case 430:  /* *m68k.md:6875 */
      ro[0] = *(ro_loc[0] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 1), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XVECEXP (pat, 0, 1), 0), 0));
      break;

    case 429:  /* *tablejump_internal */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 0), 1));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XVECEXP (pat, 0, 1), 0), 0));
      break;

    case 427:  /* *bltgt_rev */
    case 426:  /* *bunlt_rev */
    case 425:  /* *bunle_rev */
    case 424:  /* *bungt_rev */
    case 423:  /* *bunge_rev */
    case 422:  /* *buneq_rev */
    case 421:  /* *bunordered_rev */
    case 420:  /* *bordered_rev */
    case 419:  /* *bleu_rev */
    case 418:  /* *ble_rev */
    case 417:  /* *bgeu_rev */
    case 416:  /* *bge_rev */
    case 415:  /* *bltu_rev */
    case 414:  /* *blt_rev */
    case 413:  /* *bgtu_rev */
    case 412:  /* *bgt_rev */
    case 411:  /* *bne_rev */
    case 410:  /* *beq_rev */
      ro[0] = *(ro_loc[0] = &XEXP (XEXP (XEXP (pat, 1), 2), 0));
      break;

    case 409:  /* bltgt */
    case 408:  /* bunlt */
    case 407:  /* bunle */
    case 406:  /* bungt */
    case 405:  /* bunge */
    case 404:  /* buneq */
    case 403:  /* bunordered */
    case 402:  /* bordered */
    case 401:  /* bleu */
    case 400:  /* ble */
    case 399:  /* bgeu */
    case 398:  /* bge */
    case 397:  /* bltu */
    case 396:  /* blt */
    case 395:  /* bgtu */
    case 394:  /* bgt */
    case 393:  /* bne */
    case 392:  /* beq */
      ro[0] = *(ro_loc[0] = &XEXP (XEXP (XEXP (pat, 1), 1), 0));
      break;

    case 391:  /* blt0_di */
    case 390:  /* bge0_di */
      ro[0] = *(ro_loc[0] = &XEXP (XEXP (XEXP (pat, 1), 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (pat, 1), 1), 0));
      break;

    case 389:  /* bne0_di */
    case 388:  /* beq0_di */
      ro[0] = *(ro_loc[0] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 1), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XVECEXP (pat, 0, 1), 0));
      break;

    case 365:  /* scc_di_5200 */
    case 364:  /* scc_di */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (pat, 1));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (pat, 1), 0));
      ro[3] = *(ro_loc[3] = &XEXP (XEXP (pat, 1), 1));
      break;

    case 363:  /* scc0_di_5200 */
    case 362:  /* scc0_di */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (pat, 1));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (pat, 1), 0));
      break;

    case 361:  /* *m68k.md:5911 */
    case 360:  /* *m68k.md:5885 */
      ro[0] = *(ro_loc[0] = &XEXP (XEXP (XEXP (pat, 1), 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (pat, 1), 0), 1));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (pat, 1), 0), 2));
      break;

    case 358:  /* *m68k.md:5853 */
    case 357:  /* *m68k.md:5842 */
    case 353:  /* *m68k.md:5785 */
    case 352:  /* *m68k.md:5774 */
      ro[0] = *(ro_loc[0] = &XEXP (XEXP (pat, 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (pat, 0), 1));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (pat, 0), 2));
      break;

    case 351:  /* *m68k.md:5759 */
      ro[0] = *(ro_loc[0] = &XEXP (XEXP (pat, 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (pat, 0), 1));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (pat, 0), 2));
      ro[3] = *(ro_loc[3] = &XEXP (XEXP (pat, 1), 1));
      recog_data.dup_loc[0] = &XEXP (XEXP (XEXP (pat, 1), 0), 0);
      recog_data.dup_num[0] = 0;
      recog_data.dup_loc[1] = &XEXP (XEXP (XEXP (pat, 1), 0), 1);
      recog_data.dup_num[1] = 1;
      recog_data.dup_loc[2] = &XEXP (XEXP (XEXP (pat, 1), 0), 2);
      recog_data.dup_num[2] = 2;
      break;

    case 356:  /* *m68k.md:5823 */
    case 355:  /* *m68k.md:5815 */
    case 350:  /* *m68k.md:5740 */
    case 349:  /* *m68k.md:5724 */
    case 348:  /* *m68k.md:5685 */
    case 346:  /* *m68k.md:5631 */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (pat, 1), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (pat, 1), 1));
      ro[3] = *(ro_loc[3] = &XEXP (XEXP (pat, 1), 2));
      break;

    case 347:  /* *m68k.md:5670 */
    case 345:  /* *m68k.md:5616 */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (pat, 1), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (pat, 1), 2));
      break;

    case 359:  /* *m68k.md:5864 */
    case 354:  /* *m68k.md:5804 */
    case 344:  /* *m68k.md:5577 */
      ro[0] = *(ro_loc[0] = &XEXP (XEXP (pat, 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (pat, 0), 1));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (pat, 0), 2));
      ro[3] = *(ro_loc[3] = &XEXP (pat, 1));
      break;

    case 343:  /* *m68k.md:5562 */
      ro[0] = *(ro_loc[0] = &XEXP (XEXP (pat, 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (pat, 0), 2));
      ro[2] = *(ro_loc[2] = &XEXP (pat, 1));
      break;

    case 342:  /* *bclrmemqi_ext */
      ro[0] = *(ro_loc[0] = &XEXP (XEXP (pat, 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XEXP (pat, 0), 2), 1), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (pat, 0), 2), 1));
      break;

    case 341:  /* bclrmemqi */
      ro[0] = *(ro_loc[0] = &XEXP (XEXP (pat, 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (pat, 0), 2), 1));
      break;

    case 340:  /* *bsetmemqi_ext */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XEXP (XEXP (pat, 1), 0), 0), 1), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (XEXP (pat, 1), 0), 0), 1));
      recog_data.dup_loc[0] = &XEXP (XEXP (pat, 1), 1);
      recog_data.dup_num[0] = 0;
      break;

    case 339:  /* bsetmemqi */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XEXP (pat, 1), 0), 0), 1));
      recog_data.dup_loc[0] = &XEXP (XEXP (pat, 1), 1);
      recog_data.dup_num[0] = 0;
      break;

    case 315:  /* subreg1lshrdi_const32 */
    case 304:  /* subregsi1ashrdi_const32 */
    case 303:  /* subreghi1ashrdi_const32 */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (pat, 1), 0), 0));
      break;

    case 290:  /* ashldi_sexthi */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XVECEXP (pat, 0, 1), 0));
      break;

    case 289:  /* ashldi_extsi */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (pat, 1), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (pat, 1), 0));
      break;

    case 288:  /* *m68k.md:4530 */
    case 286:  /* *m68k.md:4518 */
    case 265:  /* *m68k.md:4175 */
    case 263:  /* *m68k.md:4163 */
      ro[0] = *(ro_loc[0] = &XEXP (XEXP (pat, 0), 0));
      recog_data.dup_loc[0] = &XEXP (XEXP (pat, 1), 0);
      recog_data.dup_num[0] = 0;
      break;

    case 226:  /* udivmodhi4 */
    case 225:  /* divmodhi4 */
    case 224:  /* *m68k.md:3525 */
    case 223:  /* *m68k.md:3507 */
    case 222:  /* *m68k.md:3483 */
    case 221:  /* *m68k.md:3465 */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 1));
      ro[3] = *(ro_loc[3] = &XEXP (XVECEXP (pat, 0, 1), 0));
      recog_data.dup_loc[0] = &XEXP (XEXP (XVECEXP (pat, 0, 1), 1), 0);
      recog_data.dup_num[0] = 1;
      recog_data.dup_loc[1] = &XEXP (XEXP (XVECEXP (pat, 0, 1), 1), 1);
      recog_data.dup_num[1] = 2;
      break;

    case 192:  /* const_smulsi3_highpart */
    case 190:  /* const_umulsi3_highpart */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XVECEXP (pat, 0, 1), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0), 0), 0), 0));
      ro[3] = *(ro_loc[3] = &XEXP (XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0), 0), 1));
      break;

    case 191:  /* *m68k.md:3260 */
    case 189:  /* *m68k.md:3217 */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XVECEXP (pat, 0, 1), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0), 0), 0), 0));
      ro[3] = *(ro_loc[3] = &XEXP (XEXP (XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0), 0), 1), 0));
      break;

    case 188:  /* *m68k.md:3181 */
    case 186:  /* *m68k.md:3146 */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 1));
      ro[3] = *(ro_loc[3] = &XEXP (XVECEXP (pat, 0, 1), 0));
      recog_data.dup_loc[0] = &XEXP (XEXP (XEXP (XEXP (XEXP (XVECEXP (pat, 0, 1), 1), 0), 0), 0), 0);
      recog_data.dup_num[0] = 1;
      recog_data.dup_loc[1] = &XEXP (XEXP (XEXP (XEXP (XVECEXP (pat, 0, 1), 1), 0), 0), 1);
      recog_data.dup_num[1] = 2;
      break;

    case 187:  /* *m68k.md:3170 */
    case 185:  /* *m68k.md:3131 */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 1));
      ro[3] = *(ro_loc[3] = &XEXP (XVECEXP (pat, 0, 1), 0));
      recog_data.dup_loc[0] = &XEXP (XEXP (XEXP (XEXP (XEXP (XVECEXP (pat, 0, 1), 1), 0), 0), 0), 0);
      recog_data.dup_num[0] = 1;
      recog_data.dup_loc[1] = &XEXP (XEXP (XEXP (XEXP (XEXP (XVECEXP (pat, 0, 1), 1), 0), 0), 1), 0);
      recog_data.dup_num[1] = 2;
      break;

    case 247:  /* iorsi_zexthi_ashl16 */
    case 183:  /* umulhisi3 */
    case 179:  /* mulhisi3 */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (pat, 1), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (pat, 1), 1), 0));
      break;

    case 156:  /* subdi_dishl32 */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (pat, 1), 1), 0));
      recog_data.dup_loc[0] = &XEXP (XEXP (pat, 1), 0);
      recog_data.dup_num[0] = 0;
      break;

    case 155:  /* subdi_sexthishl32 */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 1), 0), 0));
      ro[3] = *(ro_loc[3] = &XEXP (XVECEXP (pat, 0, 1), 0));
      break;

    case 201:  /* mulxf3_floatqi_68881 */
    case 200:  /* muldf3_floatqi_68881 */
    case 199:  /* mulsf3_floatqi_68881 */
    case 198:  /* mulxf3_floathi_68881 */
    case 197:  /* muldf3_floathi_68881 */
    case 196:  /* mulsf3_floathi_68881 */
    case 195:  /* mulxf3_floatsi_68881 */
    case 194:  /* muldf3_floatsi_68881 */
    case 193:  /* mulsf3_floatsi_68881 */
    case 149:  /* addxf3_floatqi_68881 */
    case 148:  /* adddf3_floatqi_68881 */
    case 147:  /* addsf3_floatqi_68881 */
    case 146:  /* addxf3_floathi_68881 */
    case 145:  /* adddf3_floathi_68881 */
    case 144:  /* addsf3_floathi_68881 */
    case 143:  /* addxf3_floatsi_68881 */
    case 142:  /* adddf3_floatsi_68881 */
    case 141:  /* addsf3_floatsi_68881 */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (pat, 1), 1));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (pat, 1), 0), 0));
      break;

    case 257:  /* *m68k.md:4084 */
    case 254:  /* *m68k.md:4063 */
    case 246:  /* *m68k.md:3903 */
    case 243:  /* *m68k.md:3882 */
    case 236:  /* *m68k.md:3739 */
    case 233:  /* *m68k.md:3718 */
    case 140:  /* *m68k.md:2721 */
    case 137:  /* *m68k.md:2626 */
      ro[0] = *(ro_loc[0] = &XEXP (XEXP (pat, 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (pat, 1), 0));
      recog_data.dup_loc[0] = &XEXP (XEXP (pat, 1), 1);
      recog_data.dup_num[0] = 0;
      break;

    case 338:  /* *m68k.md:5484 */
    case 336:  /* *m68k.md:5470 */
    case 333:  /* *m68k.md:5441 */
    case 331:  /* *m68k.md:5411 */
    case 327:  /* *m68k.md:5362 */
    case 325:  /* *m68k.md:5348 */
    case 314:  /* *m68k.md:5066 */
    case 312:  /* *m68k.md:5052 */
    case 300:  /* *m68k.md:4822 */
    case 298:  /* *m68k.md:4808 */
    case 256:  /* *m68k.md:4077 */
    case 253:  /* *m68k.md:4056 */
    case 245:  /* *m68k.md:3896 */
    case 242:  /* *m68k.md:3875 */
    case 235:  /* *m68k.md:3732 */
    case 232:  /* *m68k.md:3711 */
    case 163:  /* *m68k.md:2960 */
    case 161:  /* *m68k.md:2946 */
    case 139:  /* *m68k.md:2698 */
    case 136:  /* *m68k.md:2577 */
      ro[0] = *(ro_loc[0] = &XEXP (XEXP (pat, 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (pat, 1), 1));
      recog_data.dup_loc[0] = &XEXP (XEXP (pat, 1), 0);
      recog_data.dup_num[0] = 0;
      break;

    case 215:  /* divxf3_floatqi_68881 */
    case 214:  /* divdf3_floatqi_68881 */
    case 213:  /* divsf3_floatqi_68881 */
    case 212:  /* divxf3_floathi_68881 */
    case 211:  /* divdf3_floathi_68881 */
    case 210:  /* divsf3_floathi_68881 */
    case 209:  /* divxf3_floatsi_68881 */
    case 208:  /* divdf3_floatsi_68881 */
    case 207:  /* divsf3_floatsi_68881 */
    case 172:  /* subxf3_floatqi_68881 */
    case 171:  /* subdf3_floatqi_68881 */
    case 170:  /* subsf3_floatqi_68881 */
    case 169:  /* subxf3_floathi_68881 */
    case 168:  /* subdf3_floathi_68881 */
    case 167:  /* subsf3_floathi_68881 */
    case 166:  /* subxf3_floatsi_68881 */
    case 165:  /* subdf3_floatsi_68881 */
    case 164:  /* subsf3_floatsi_68881 */
    case 159:  /* *m68k.md:2931 */
    case 134:  /* *m68k.md:2514 */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (pat, 1), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (pat, 1), 1), 0));
      break;

    case 337:  /* rotrqi3 */
    case 335:  /* rotrhi3 */
    case 334:  /* rotrsi3 */
    case 332:  /* rotlqi3 */
    case 330:  /* rotlhi3 */
    case 329:  /* rotlsi3 */
    case 326:  /* lshrqi3 */
    case 324:  /* lshrhi3 */
    case 323:  /* lshrsi3 */
    case 322:  /* lshrsi_17_24 */
    case 319:  /* *lshrdi3_const */
    case 313:  /* ashrqi3 */
    case 311:  /* ashrhi3 */
    case 310:  /* ashrsi3 */
    case 308:  /* ashrdi_const */
    case 302:  /* *m68k.md:4840 */
    case 299:  /* ashlqi3 */
    case 297:  /* ashlhi3 */
    case 296:  /* ashlsi3 */
    case 295:  /* ashlsi_17_24 */
    case 293:  /* *ashldi3 */
    case 255:  /* xorqi3 */
    case 252:  /* xorhi3 */
    case 251:  /* xorsi3_5200 */
    case 250:  /* xorsi3_internal */
    case 249:  /* xordi3 */
    case 244:  /* iorqi3 */
    case 241:  /* iorhi3 */
    case 240:  /* iorsi3_5200 */
    case 239:  /* iorsi3_internal */
    case 238:  /* iordi3 */
    case 234:  /* andqi3 */
    case 231:  /* andhi3 */
    case 230:  /* andsi3_5200 */
    case 229:  /* andsi3_internal */
    case 228:  /* *andsi3_split */
    case 227:  /* anddi3 */
    case 220:  /* divdf3_cf */
    case 219:  /* divsf3_cf */
    case 218:  /* divxf3_68881 */
    case 217:  /* divdf3_68881 */
    case 216:  /* divsf3_68881 */
    case 206:  /* fmuldf3_cf */
    case 205:  /* fmulsf3_cf */
    case 204:  /* mulxf3_68881 */
    case 203:  /* mulsf_68881 */
    case 202:  /* muldf_68881 */
    case 182:  /* *mulsi3_cf */
    case 181:  /* *mulsi3_68020 */
    case 178:  /* mulhi3 */
    case 177:  /* subdf3_cf */
    case 176:  /* subsf3_cf */
    case 175:  /* subxf3_68881 */
    case 174:  /* subdf3_68881 */
    case 173:  /* subsf3_68881 */
    case 162:  /* subqi3 */
    case 160:  /* subhi3 */
    case 158:  /* subsi3 */
    case 154:  /* adddf3_cf */
    case 153:  /* addsf3_cf */
    case 152:  /* addxf3_68881 */
    case 151:  /* adddf3_68881 */
    case 150:  /* addsf3_68881 */
    case 138:  /* addqi3 */
    case 135:  /* addhi3 */
    case 133:  /* *addsi3_5200 */
    case 132:  /* *addsi3_internal */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (pat, 1), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (pat, 1), 1));
      break;

    case 131:  /* addsi_lshrsi_31 */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (pat, 1), 0), 0));
      recog_data.dup_loc[0] = &XEXP (XEXP (pat, 1), 1);
      recog_data.dup_num[0] = 1;
      break;

    case 157:  /* subdi3 */
    case 130:  /* adddi3 */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 1));
      ro[3] = *(ro_loc[3] = &XEXP (XVECEXP (pat, 0, 1), 0));
      break;

    case 440:  /* *symbolic_call_value_bsr */
    case 439:  /* *symbolic_call_value_jsr */
    case 438:  /* *non_symbolic_call_value */
    case 436:  /* *sibcall_value */
    case 248:  /* iorsi_zext */
    case 237:  /* iordi_zext */
    case 184:  /* *mulhisisi3_z */
    case 180:  /* *mulhisisi3_s */
    case 129:  /* adddi_dishl32 */
    case 128:  /* *adddi_dilshr32_cf */
    case 127:  /* *adddi_dilshr32 */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (pat, 1), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (pat, 1), 1));
      break;

    case 126:  /* adddi_sexthishl32 */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 1));
      ro[3] = *(ro_loc[3] = &XEXP (XVECEXP (pat, 0, 1), 0));
      break;

    case 125:  /* adddi_lshrdi_63 */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XVECEXP (pat, 0, 1), 0));
      recog_data.dup_loc[0] = &XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 1);
      recog_data.dup_num[0] = 1;
      break;

    case 104:  /* fix_truncdfqi2 */
    case 103:  /* fix_truncdfhi2 */
    case 102:  /* fix_truncdfsi2 */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XVECEXP (pat, 0, 1), 0));
      ro[3] = *(ro_loc[3] = &XEXP (XVECEXP (pat, 0, 2), 0));
      break;

    case 76:  /* extendplussidi */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (pat, 1), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (pat, 1), 0), 1));
      break;

    case 307:  /* *ashrdi_const32_mem */
    case 75:  /* extendsidi2 */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XVECEXP (pat, 0, 1), 0));
      break;

    case 456:  /* truncxfsf2 */
    case 455:  /* truncxfdf2 */
    case 454:  /* extenddfxf2 */
    case 453:  /* extendsfxf2 */
    case 328:  /* rotlsi_16 */
    case 321:  /* lshrsi_16 */
    case 320:  /* lshrsi_31 */
    case 318:  /* *lshrdi_const63 */
    case 317:  /* *lshrdi_const32 */
    case 316:  /* *lshrdi3_const1 */
    case 309:  /* ashrsi_31 */
    case 306:  /* *ashrdi_const32 */
    case 305:  /* *ashrdi3_const1 */
    case 301:  /* ashrsi_16 */
    case 294:  /* ashlsi_16 */
    case 292:  /* *ashldi3_const32 */
    case 291:  /* *ashldi3_const1 */
    case 287:  /* one_cmplqi2 */
    case 285:  /* one_cmplhi2 */
    case 284:  /* one_cmplsi2_5200 */
    case 283:  /* one_cmplsi2_internal */
    case 282:  /* one_cmpldi2 */
    case 281:  /* clzsi2 */
    case 280:  /* absdf2_cf */
    case 279:  /* abssf2_cf */
    case 278:  /* absxf2_68881 */
    case 277:  /* absdf2_68881 */
    case 276:  /* abssf2_68881 */
    case 275:  /* sqrtdf2_cf */
    case 274:  /* sqrtsf2_cf */
    case 273:  /* sqrtxf2_68881 */
    case 272:  /* sqrtdf2_68881 */
    case 271:  /* sqrtsf2_68881 */
    case 270:  /* negdf2_cf */
    case 269:  /* negsf2_cf */
    case 268:  /* negxf2_68881 */
    case 267:  /* negdf2_68881 */
    case 266:  /* negsf2_68881 */
    case 264:  /* negqi2 */
    case 262:  /* neghi2 */
    case 261:  /* negsi2_5200 */
    case 260:  /* negsi2_internal */
    case 259:  /* negdi2_5200 */
    case 258:  /* negdi2_internal */
    case 124:  /* fixdfsi2_cf */
    case 123:  /* fixsfsi2_cf */
    case 122:  /* fixxfsi2_68881 */
    case 121:  /* fixdfsi2_68881 */
    case 120:  /* fixsfsi2_68881 */
    case 119:  /* fixdfhi2_cf */
    case 118:  /* fixsfhi2_cf */
    case 117:  /* fixxfhi2_68881 */
    case 116:  /* fixdfhi2_68881 */
    case 115:  /* fixsfhi2_68881 */
    case 114:  /* fixdfqi2_cf */
    case 113:  /* fixsfqi2_cf */
    case 112:  /* fixxfqi2_68881 */
    case 111:  /* fixdfqi2_68881 */
    case 110:  /* fixsfqi2_68881 */
    case 109:  /* ftruncdf2_cf */
    case 108:  /* ftruncsf2_cf */
    case 107:  /* ftruncxf2_68881 */
    case 106:  /* ftruncdf2_68881 */
    case 105:  /* ftruncsf2_68881 */
    case 101:  /* floatqidf2_cf */
    case 100:  /* floatqisf2_cf */
    case 99:  /* floatqixf2_68881 */
    case 98:  /* floatqidf2_68881 */
    case 97:  /* floatqisf2_68881 */
    case 96:  /* floathidf2_cf */
    case 95:  /* floathisf2_cf */
    case 94:  /* floathixf2_68881 */
    case 93:  /* floathidf2_68881 */
    case 92:  /* floathisf2_68881 */
    case 91:  /* floatsidf2_cf */
    case 90:  /* floatsisf2_cf */
    case 89:  /* floatsixf2_68881 */
    case 88:  /* floatsidf2_68881 */
    case 87:  /* floatsisf2_68881 */
    case 86:  /* *truncdfsf2_68881 */
    case 85:  /* truncdfsf2_cf */
    case 84:  /* *m68k.md:2013 */
    case 83:  /* extendsfdf2_cf */
    case 82:  /* *m68k.md:1953 */
    case 81:  /* *68k_extendqisi2 */
    case 80:  /* *cfv4_extendqisi2 */
    case 79:  /* extendqihi2 */
    case 78:  /* *68k_extendhisi2 */
    case 77:  /* *cfv4_extendhisi2 */
    case 74:  /* extendhidi2 */
    case 73:  /* extendqidi2 */
    case 72:  /* zero_extendqisi2 */
    case 71:  /* *zero_extendqisi2_cfv4 */
    case 70:  /* *zero_extendqihi2 */
    case 69:  /* zero_extendhisi2 */
    case 68:  /* *zero_extendhisi2_cf */
    case 67:  /* *zero_extendsidi2 */
    case 66:  /* zero_extendhidi2 */
    case 65:  /* zero_extendqidi2 */
    case 64:  /* *zero_extend_dec */
    case 63:  /* *zero_extend_inc */
    case 62:  /* truncsihi2 */
    case 61:  /* trunchiqi2 */
    case 60:  /* truncsiqi2 */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (pat, 1), 0));
      break;

    case 437:  /* *call */
    case 435:  /* *sibcall */
    case 47:  /* *movstrictqi_cf */
    case 46:  /* *m68k.md:1088 */
    case 43:  /* *m68k.md:1058 */
    case 42:  /* *m68k.md:1052 */
      ro[0] = *(ro_loc[0] = &XEXP (XEXP (pat, 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (pat, 1));
      break;

    case 450:  /* load_got */
    case 387:  /* *fsole_1 */
    case 386:  /* *fsolt_1 */
    case 385:  /* *fsoge_1 */
    case 384:  /* *fsogt_1 */
    case 383:  /* *sltgt_1 */
    case 382:  /* *sunlt_1 */
    case 381:  /* *sunle_1 */
    case 380:  /* *sungt_1 */
    case 379:  /* *sunge_1 */
    case 378:  /* *suneq_1 */
    case 377:  /* *sunordered_1 */
    case 376:  /* *sordered_1 */
    case 375:  /* *sls */
    case 374:  /* *m68k.md:6049 */
    case 373:  /* *scc */
    case 372:  /* *m68k.md:6030 */
    case 371:  /* *m68k.md:6021 */
    case 370:  /* *m68k.md:6012 */
    case 369:  /* *m68k.md:6003 */
    case 368:  /* *m68k.md:5994 */
    case 367:  /* *m68k.md:5985 */
    case 366:  /* *m68k.md:5976 */
    case 35:  /* *movsi_const0 */
    case 34:  /* *movsi_const0_68040_60 */
    case 33:  /* *movsi_const0_68000_10 */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      break;

    case 31:  /* *m68k.md:771 */
    case 30:  /* *m68k.md:748 */
    case 29:  /* *m68k.md:735 */
      ro[0] = *(ro_loc[0] = &XEXP (XEXP (XEXP (pat, 1), 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (pat, 1), 0), 2));
      break;

    case 28:  /* *m68k.md:718 */
    case 27:  /* *m68k.md:703 */
      ro[0] = *(ro_loc[0] = &XEXP (XEXP (XEXP (pat, 1), 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XEXP (XEXP (pat, 1), 0), 2), 1), 0));
      break;

    case 26:  /* *m68k.md:686 */
    case 25:  /* *m68k.md:673 */
    case 24:  /* *m68k.md:657 */
      ro[0] = *(ro_loc[0] = &XEXP (XEXP (XEXP (pat, 1), 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XEXP (pat, 1), 0), 2), 1));
      break;

    case 13:  /* cmpdi */
      ro[0] = *(ro_loc[0] = &XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 1));
      ro[2] = *(ro_loc[2] = &XEXP (XVECEXP (pat, 0, 1), 0));
      break;

    case 12:  /* *cmpdi_internal */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 1), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 1));
      break;

    case 23:  /* *cmpxf_cf */
    case 22:  /* *cmpdf_cf */
    case 21:  /* *cmpsf_cf */
    case 20:  /* *cmpxf_68881 */
    case 19:  /* *cmpdf_68881 */
    case 18:  /* *cmpsf_68881 */
    case 17:  /* *m68k.md:585 */
    case 16:  /* *m68k.md:546 */
    case 15:  /* *cmpsi_cf */
    case 14:  /* *m68k.md:486 */
    case 11:  /* tstdf_cf */
    case 10:  /* tstsf_cf */
    case 9:  /* tstxf_68881 */
    case 8:  /* tstdf_68881 */
    case 7:  /* tstsf_68881 */
      ro[0] = *(ro_loc[0] = &XEXP (XEXP (pat, 1), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (pat, 1), 1));
      break;

    case 428:  /* jump */
    case 6:  /* *tstqi_internal */
    case 5:  /* *tsthi_internal */
    case 4:  /* *tstsi_internal */
    case 3:  /* *tstsi_internal_68020_cf */
      ro[0] = *(ro_loc[0] = &XEXP (XEXP (pat, 1), 0));
      break;

    case 2:  /* tstdi */
      ro[0] = *(ro_loc[0] = &XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XVECEXP (pat, 0, 1), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XVECEXP (pat, 0, 2), 0));
      break;

    case 464:  /* *conditional_trap */
    case 452:  /* *lea */
    case 59:  /* pushasi */
    case 58:  /* *m68k.md:1546 */
    case 57:  /* *m68k.md:1506 */
    case 56:  /* *m68k.md:1492 */
    case 55:  /* *m68k.md:1453 */
    case 54:  /* *m68k.md:1414 */
    case 53:  /* movdf_cf_hard */
    case 52:  /* movdf_cf_soft */
    case 51:  /* *m68k.md:1293 */
    case 50:  /* movsf_cf_hard */
    case 49:  /* movsf_cf_soft */
    case 48:  /* *m68k.md:1146 */
    case 45:  /* *m68k.md:1076 */
    case 44:  /* *m68k.md:1070 */
    case 41:  /* *m68k.md:1040 */
    case 40:  /* *m68k.md:1034 */
    case 39:  /* *m68k.md:1018 */
    case 38:  /* *movsi_cf */
    case 37:  /* *movsi_m68k2 */
    case 36:  /* *movsi_m68k */
    case 32:  /* pushexthisi_const */
    case 1:  /* pushdi */
    case 0:  /* *movdf_internal */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (pat, 1));
      break;

    }
}
