/* Generated automatically by the program `genattr'
   from the machine description file `md'.  */

#ifndef GCC_INSN_ATTR_H
#define GCC_INSN_ATTR_H

#define HAVE_ATTR_alternative
#define get_attr_alternative(insn) which_alternative
#define HAVE_ATTR_cpu
enum attr_cpu {CPU_CFV1, CPU_CFV2, CPU_CFV3, CPU_CFV4, CPU_UNKNOWN};
extern enum attr_cpu get_attr_cpu (void);

#define HAVE_ATTR_mac
enum attr_mac {MAC_NO, MAC_CF_MAC, MAC_CF_EMAC};
extern enum attr_mac get_attr_mac (void);

#define HAVE_ATTR_type
enum attr_type {TYPE_ALU_L, TYPE_ALUQ_L, TYPE_ALUX_L, TYPE_BCC, TYPE_BITR, TYPE_BITRW, TYPE_BRA, TYPE_BSR, TYPE_CLR, TYPE_CLR_L, TYPE_CMP, TYPE_CMP_L, TYPE_DIV_W, TYPE_DIV_L, TYPE_EXT, TYPE_FALU, TYPE_FBCC, TYPE_FCMP, TYPE_FDIV, TYPE_FMOVE, TYPE_FMUL, TYPE_FNEG, TYPE_FSQRT, TYPE_FTST, TYPE_IB, TYPE_IGNORE, TYPE_JMP, TYPE_JSR, TYPE_LEA, TYPE_LINK, TYPE_MOV3Q_L, TYPE_MOVE, TYPE_MOVE_L, TYPE_MOVEQ_L, TYPE_MUL_W, TYPE_MUL_L, TYPE_MVSZ, TYPE_NEG_L, TYPE_NOP, TYPE_PEA, TYPE_RTS, TYPE_SCC, TYPE_SHIFT, TYPE_TRAP, TYPE_TST, TYPE_TST_L, TYPE_UNLK, TYPE_UNKNOWN};
extern enum attr_type get_attr_type (rtx);

#define HAVE_ATTR_opx
extern int get_attr_opx (rtx);
#define HAVE_ATTR_opy
extern int get_attr_opy (rtx);
#define HAVE_ATTR_opy_type
enum attr_opy_type {OPY_TYPE_NONE, OPY_TYPE_RN, OPY_TYPE_FPN, OPY_TYPE_MEM1, OPY_TYPE_MEM234, OPY_TYPE_MEM5, OPY_TYPE_MEM6, OPY_TYPE_MEM7, OPY_TYPE_IMM_Q, OPY_TYPE_IMM_W, OPY_TYPE_IMM_L};
extern enum attr_opy_type get_attr_opy_type (rtx);

#define HAVE_ATTR_opx_type
enum attr_opx_type {OPX_TYPE_NONE, OPX_TYPE_RN, OPX_TYPE_FPN, OPX_TYPE_MEM1, OPX_TYPE_MEM234, OPX_TYPE_MEM5, OPX_TYPE_MEM6, OPX_TYPE_MEM7, OPX_TYPE_IMM_Q, OPX_TYPE_IMM_W, OPX_TYPE_IMM_L};
extern enum attr_opx_type get_attr_opx_type (rtx);

#define HAVE_ATTR_opx_access
enum attr_opx_access {OPX_ACCESS_NONE, OPX_ACCESS_R, OPX_ACCESS_W, OPX_ACCESS_RW};
extern enum attr_opx_access get_attr_opx_access (rtx);

#define HAVE_ATTR_op_mem
enum attr_op_mem {OP_MEM_00, OP_MEM_10, OP_MEM_I0, OP_MEM_01, OP_MEM_0I, OP_MEM_11, OP_MEM_I1, OP_MEM_1I};
extern enum attr_op_mem get_attr_op_mem (rtx);

#define HAVE_ATTR_size
enum attr_size {SIZE_1, SIZE_2, SIZE_3};
extern enum attr_size get_attr_size (rtx);

#define HAVE_ATTR_ok_for_coldfire
enum attr_ok_for_coldfire {OK_FOR_COLDFIRE_YES, OK_FOR_COLDFIRE_NO};
extern enum attr_ok_for_coldfire get_attr_ok_for_coldfire (rtx);

#define HAVE_ATTR_enabled
extern int get_attr_enabled (rtx);

#define INSN_SCHEDULING

/* DFA based pipeline interface.  */
#ifndef AUTOMATON_ALTS
#define AUTOMATON_ALTS 0
#endif


#ifndef AUTOMATON_STATE_ALTS
#define AUTOMATON_STATE_ALTS 0
#endif

#ifndef CPU_UNITS_QUERY
#define CPU_UNITS_QUERY 0
#endif

#define init_sched_attrs() do { } while (0)

/* Internal insn code number used by automata.  */
extern int internal_dfa_insn_code (rtx);

/* Insn latency time defined in define_insn_reservation. */
extern int insn_default_latency (rtx);

/* Return nonzero if there is a bypass for given insn
   which is a data producer.  */
extern int bypass_p (rtx);

/* Insn latency time on data consumed by the 2nd insn.
   Use the function if bypass_p returns nonzero for
   the 1st insn. */
extern int insn_latency (rtx, rtx);

/* Maximal insn latency time possible of all bypasses for this insn.
   Use the function if bypass_p returns nonzero for
   the 1st insn. */
extern int maximal_insn_latency (rtx);


#if AUTOMATON_ALTS
/* The following function returns number of alternative
   reservations of given insn.  It may be used for better
   insns scheduling heuristics. */
extern int insn_alts (rtx);

#endif

/* Maximal possible number of insns waiting results being
   produced by insns whose execution is not finished. */
extern const int max_insn_queue_index;

/* Pointer to data describing current state of DFA.  */
typedef void *state_t;

/* Size of the data in bytes.  */
extern int state_size (void);

/* Initiate given DFA state, i.e. Set up the state
   as all functional units were not reserved.  */
extern void state_reset (state_t);
/* The following function returns negative value if given
   insn can be issued in processor state described by given
   DFA state.  In this case, the DFA state is changed to
   reflect the current and future reservations by given
   insn.  Otherwise the function returns minimal time
   delay to issue the insn.  This delay may be zero
   for superscalar or VLIW processors.  If the second
   parameter is NULL the function changes given DFA state
   as new processor cycle started.  */
extern int state_transition (state_t, rtx);

#if AUTOMATON_STATE_ALTS
/* The following function returns number of possible
   alternative reservations of given insn in given
   DFA state.  It may be used for better insns scheduling
   heuristics.  By default the function is defined if
   macro AUTOMATON_STATE_ALTS is defined because its
   implementation may require much memory.  */
extern int state_alts (state_t, rtx);
#endif

extern int min_issue_delay (state_t, rtx);
/* The following function returns nonzero if no one insn
   can be issued in current DFA state. */
extern int state_dead_lock_p (state_t);
/* The function returns minimal delay of issue of the 2nd
   insn after issuing the 1st insn in given DFA state.
   The 1st insn should be issued in given state (i.e.
    state_transition should return negative value for
    the insn and the state).  Data dependencies between
    the insns are ignored by the function.  */
extern int min_insn_conflict_delay (state_t, rtx, rtx);
/* The following function outputs reservations for given
   insn as they are described in the corresponding
   define_insn_reservation.  */
extern void print_reservation (FILE *, rtx);

#if CPU_UNITS_QUERY
/* The following function returns code of functional unit
   with given name (see define_cpu_unit). */
extern int get_cpu_unit_code (const char *);
/* The following function returns nonzero if functional
   unit with given code is currently reserved in given
   DFA state.  */
extern int cpu_unit_reservation_p (state_t, int);
#endif

/* The following function returns true if insn
   has a dfa reservation.  */
extern bool insn_has_dfa_reservation_p (rtx);

/* Clean insn code cache.  It should be called if there
   is a chance that condition value in a
   define_insn_reservation will be changed after
   last call of dfa_start.  */
extern void dfa_clean_insn_cache (void);

extern void dfa_clear_single_insn_cache (rtx);

/* Initiate and finish work with DFA.  They should be
   called as the first and the last interface
   functions.  */
extern void dfa_start (void);
extern void dfa_finish (void);

#define ATTR_FLAG_forward	0x1
#define ATTR_FLAG_backward	0x2
#define ATTR_FLAG_likely	0x4
#define ATTR_FLAG_very_likely	0x8
#define ATTR_FLAG_unlikely	0x10
#define ATTR_FLAG_very_unlikely	0x20

#endif /* GCC_INSN_ATTR_H */
