/* Generated automatically by the program `genopinit'
from the machine description file `md'.  */

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "tm.h"
#include "rtl.h"
#include "tm_p.h"
#include "flags.h"
#include "insn-config.h"
#include "recog.h"
#include "expr.h"
#include "optabs.h"
#include "reload.h"

void
init_all_optabs (void)
{
#ifdef FIXUNS_TRUNC_LIKE_FIX_TRUNC
  int i, j;
#endif

  set_convert_optab_handler (trunc_optab, QImode, SImode, CODE_FOR_truncsiqi2);
  set_convert_optab_handler (trunc_optab, QImode, HImode, CODE_FOR_trunchiqi2);
  set_convert_optab_handler (trunc_optab, HImode, SImode, CODE_FOR_truncsihi2);
  set_convert_optab_handler (zext_optab, DImode, QImode, CODE_FOR_zero_extendqidi2);
  set_convert_optab_handler (zext_optab, DImode, HImode, CODE_FOR_zero_extendhidi2);
  set_convert_optab_handler (zext_optab, SImode, HImode, CODE_FOR_zero_extendhisi2);
  set_convert_optab_handler (zext_optab, SImode, QImode, CODE_FOR_zero_extendqisi2);
  set_convert_optab_handler (sext_optab, DImode, QImode, CODE_FOR_extendqidi2);
  set_convert_optab_handler (sext_optab, DImode, HImode, CODE_FOR_extendhidi2);
  set_convert_optab_handler (sext_optab, DImode, SImode, CODE_FOR_extendsidi2);
  set_convert_optab_handler (sext_optab, HImode, QImode, CODE_FOR_extendqihi2);
  if (HAVE_fix_truncdfsi2)
    set_convert_optab_handler (sfixtrunc_optab, SImode, DFmode, CODE_FOR_fix_truncdfsi2);
  if (HAVE_fix_truncdfhi2)
    set_convert_optab_handler (sfixtrunc_optab, HImode, DFmode, CODE_FOR_fix_truncdfhi2);
  if (HAVE_fix_truncdfqi2)
    set_convert_optab_handler (sfixtrunc_optab, QImode, DFmode, CODE_FOR_fix_truncdfqi2);
  set_optab_handler (add_optab, DImode, CODE_FOR_adddi3);
  if (HAVE_addhi3)
    set_optab_handler (add_optab, HImode, CODE_FOR_addhi3);
  if (HAVE_addqi3)
    set_optab_handler (add_optab, QImode, CODE_FOR_addqi3);
  set_optab_handler (sub_optab, DImode, CODE_FOR_subdi3);
  set_optab_handler (sub_optab, SImode, CODE_FOR_subsi3);
  if (HAVE_subhi3)
    set_optab_handler (sub_optab, HImode, CODE_FOR_subhi3);
  if (HAVE_subqi3)
    set_optab_handler (sub_optab, QImode, CODE_FOR_subqi3);
  set_optab_handler (smul_optab, HImode, CODE_FOR_mulhi3);
  set_optab_handler (smul_widen_optab, SImode, CODE_FOR_mulhisi3);
  set_optab_handler (umul_widen_optab, SImode, CODE_FOR_umulhisi3);
  if (HAVE_divmodhi4)
    set_optab_handler (sdivmod_optab, HImode, CODE_FOR_divmodhi4);
  if (HAVE_udivmodhi4)
    set_optab_handler (udivmod_optab, HImode, CODE_FOR_udivmodhi4);
  if (HAVE_anddi3)
    set_optab_handler (and_optab, DImode, CODE_FOR_anddi3);
  if (HAVE_andhi3)
    set_optab_handler (and_optab, HImode, CODE_FOR_andhi3);
  if (HAVE_andqi3)
    set_optab_handler (and_optab, QImode, CODE_FOR_andqi3);
  if (HAVE_iordi3)
    set_optab_handler (ior_optab, DImode, CODE_FOR_iordi3);
  if (HAVE_iorhi3)
    set_optab_handler (ior_optab, HImode, CODE_FOR_iorhi3);
  if (HAVE_iorqi3)
    set_optab_handler (ior_optab, QImode, CODE_FOR_iorqi3);
  if (HAVE_xordi3)
    set_optab_handler (xor_optab, DImode, CODE_FOR_xordi3);
  if (HAVE_xorhi3)
    set_optab_handler (xor_optab, HImode, CODE_FOR_xorhi3);
  if (HAVE_xorqi3)
    set_optab_handler (xor_optab, QImode, CODE_FOR_xorqi3);
  if (HAVE_neghi2)
    set_optab_handler (neg_optab, HImode, CODE_FOR_neghi2);
  if (HAVE_negqi2)
    set_optab_handler (neg_optab, QImode, CODE_FOR_negqi2);
  if (HAVE_clzsi2)
    set_optab_handler (clz_optab, SImode, CODE_FOR_clzsi2);
  if (HAVE_one_cmpldi2)
    set_optab_handler (one_cmpl_optab, DImode, CODE_FOR_one_cmpldi2);
  if (HAVE_one_cmplhi2)
    set_optab_handler (one_cmpl_optab, HImode, CODE_FOR_one_cmplhi2);
  if (HAVE_one_cmplqi2)
    set_optab_handler (one_cmpl_optab, QImode, CODE_FOR_one_cmplqi2);
  set_optab_handler (ashl_optab, SImode, CODE_FOR_ashlsi3);
  if (HAVE_ashlhi3)
    set_optab_handler (ashl_optab, HImode, CODE_FOR_ashlhi3);
  if (HAVE_ashlqi3)
    set_optab_handler (ashl_optab, QImode, CODE_FOR_ashlqi3);
  set_optab_handler (ashr_optab, SImode, CODE_FOR_ashrsi3);
  if (HAVE_ashrhi3)
    set_optab_handler (ashr_optab, HImode, CODE_FOR_ashrhi3);
  if (HAVE_ashrqi3)
    set_optab_handler (ashr_optab, QImode, CODE_FOR_ashrqi3);
  set_optab_handler (lshr_optab, SImode, CODE_FOR_lshrsi3);
  if (HAVE_lshrhi3)
    set_optab_handler (lshr_optab, HImode, CODE_FOR_lshrhi3);
  if (HAVE_lshrqi3)
    set_optab_handler (lshr_optab, QImode, CODE_FOR_lshrqi3);
  if (HAVE_rotlsi3)
    set_optab_handler (rotl_optab, SImode, CODE_FOR_rotlsi3);
  if (HAVE_rotlhi3)
    set_optab_handler (rotl_optab, HImode, CODE_FOR_rotlhi3);
  if (HAVE_rotlqi3)
    set_optab_handler (rotl_optab, QImode, CODE_FOR_rotlqi3);
  if (HAVE_rotrsi3)
    set_optab_handler (rotr_optab, SImode, CODE_FOR_rotrsi3);
  if (HAVE_rotrhi3)
    set_optab_handler (rotr_optab, HImode, CODE_FOR_rotrhi3);
  if (HAVE_rotrqi3)
    set_optab_handler (rotr_optab, QImode, CODE_FOR_rotrqi3);
  if (HAVE_extendsfxf2)
    set_convert_optab_handler (sext_optab, XFmode, SFmode, CODE_FOR_extendsfxf2);
  if (HAVE_extenddfxf2)
    set_convert_optab_handler (sext_optab, XFmode, DFmode, CODE_FOR_extenddfxf2);
  if (HAVE_truncxfdf2)
    set_convert_optab_handler (trunc_optab, DFmode, XFmode, CODE_FOR_truncxfdf2);
  if (HAVE_truncxfsf2)
    set_convert_optab_handler (trunc_optab, SFmode, XFmode, CODE_FOR_truncxfsf2);
  if (HAVE_sinsf2)
    set_optab_handler (sin_optab, SFmode, CODE_FOR_sinsf2);
  if (HAVE_sindf2)
    set_optab_handler (sin_optab, DFmode, CODE_FOR_sindf2);
  if (HAVE_sinxf2)
    set_optab_handler (sin_optab, XFmode, CODE_FOR_sinxf2);
  if (HAVE_cossf2)
    set_optab_handler (cos_optab, SFmode, CODE_FOR_cossf2);
  if (HAVE_cosdf2)
    set_optab_handler (cos_optab, DFmode, CODE_FOR_cosdf2);
  if (HAVE_cosxf2)
    set_optab_handler (cos_optab, XFmode, CODE_FOR_cosxf2);
  set_optab_handler (cbranch_optab, DImode, CODE_FOR_cbranchdi4);
  set_optab_handler (cstore_optab, DImode, CODE_FOR_cstoredi4);
  set_optab_handler (cbranch_optab, SImode, CODE_FOR_cbranchsi4);
  set_optab_handler (cstore_optab, SImode, CODE_FOR_cstoresi4);
  set_optab_handler (cbranch_optab, HImode, CODE_FOR_cbranchhi4);
  set_optab_handler (cstore_optab, HImode, CODE_FOR_cstorehi4);
  set_optab_handler (cbranch_optab, QImode, CODE_FOR_cbranchqi4);
  set_optab_handler (cstore_optab, QImode, CODE_FOR_cstoreqi4);
  if (HAVE_cbranchsf4)
    set_optab_handler (cbranch_optab, SFmode, CODE_FOR_cbranchsf4);
  if (HAVE_cbranchdf4)
    set_optab_handler (cbranch_optab, DFmode, CODE_FOR_cbranchdf4);
  if (HAVE_cbranchxf4)
    set_optab_handler (cbranch_optab, XFmode, CODE_FOR_cbranchxf4);
  if (HAVE_cstoresf4)
    set_optab_handler (cstore_optab, SFmode, CODE_FOR_cstoresf4);
  if (HAVE_cstoredf4)
    set_optab_handler (cstore_optab, DFmode, CODE_FOR_cstoredf4);
  if (HAVE_cstorexf4)
    set_optab_handler (cstore_optab, XFmode, CODE_FOR_cstorexf4);
  set_optab_handler (mov_optab, SImode, CODE_FOR_movsi);
  set_optab_handler (mov_optab, HImode, CODE_FOR_movhi);
  set_optab_handler (movstrict_optab, HImode, CODE_FOR_movstricthi);
  set_optab_handler (mov_optab, QImode, CODE_FOR_movqi);
  set_optab_handler (movstrict_optab, QImode, CODE_FOR_movstrictqi);
  if (HAVE_pushqi1)
    set_optab_handler (push_optab, QImode, CODE_FOR_pushqi1);
  if (HAVE_reload_insf)
    set_direct_optab_handler (reload_in_optab, SFmode, CODE_FOR_reload_insf);
  if (HAVE_reload_outsf)
    set_direct_optab_handler (reload_out_optab, SFmode, CODE_FOR_reload_outsf);
  set_optab_handler (mov_optab, SFmode, CODE_FOR_movsf);
  if (HAVE_reload_indf)
    set_direct_optab_handler (reload_in_optab, DFmode, CODE_FOR_reload_indf);
  if (HAVE_reload_outdf)
    set_direct_optab_handler (reload_out_optab, DFmode, CODE_FOR_reload_outdf);
  set_optab_handler (mov_optab, DFmode, CODE_FOR_movdf);
  set_optab_handler (mov_optab, XFmode, CODE_FOR_movxf);
  set_optab_handler (mov_optab, DImode, CODE_FOR_movdi);
  set_convert_optab_handler (zext_optab, DImode, SImode, CODE_FOR_zero_extendsidi2);
  if (HAVE_zero_extendqihi2)
    set_convert_optab_handler (zext_optab, HImode, QImode, CODE_FOR_zero_extendqihi2);
  set_convert_optab_handler (sext_optab, SImode, HImode, CODE_FOR_extendhisi2);
  if (HAVE_extendqisi2)
    set_convert_optab_handler (sext_optab, SImode, QImode, CODE_FOR_extendqisi2);
  if (HAVE_extendsfdf2)
    set_convert_optab_handler (sext_optab, DFmode, SFmode, CODE_FOR_extendsfdf2);
  if (HAVE_truncdfsf2)
    set_convert_optab_handler (trunc_optab, SFmode, DFmode, CODE_FOR_truncdfsf2);
  if (HAVE_floatsisf2)
    set_convert_optab_handler (sfloat_optab, SFmode, SImode, CODE_FOR_floatsisf2);
  if (HAVE_floatsidf2)
    set_convert_optab_handler (sfloat_optab, DFmode, SImode, CODE_FOR_floatsidf2);
  if (HAVE_floatsixf2)
    set_convert_optab_handler (sfloat_optab, XFmode, SImode, CODE_FOR_floatsixf2);
  if (HAVE_floathisf2)
    set_convert_optab_handler (sfloat_optab, SFmode, HImode, CODE_FOR_floathisf2);
  if (HAVE_floathidf2)
    set_convert_optab_handler (sfloat_optab, DFmode, HImode, CODE_FOR_floathidf2);
  if (HAVE_floathixf2)
    set_convert_optab_handler (sfloat_optab, XFmode, HImode, CODE_FOR_floathixf2);
  if (HAVE_floatqisf2)
    set_convert_optab_handler (sfloat_optab, SFmode, QImode, CODE_FOR_floatqisf2);
  if (HAVE_floatqidf2)
    set_convert_optab_handler (sfloat_optab, DFmode, QImode, CODE_FOR_floatqidf2);
  if (HAVE_floatqixf2)
    set_convert_optab_handler (sfloat_optab, XFmode, QImode, CODE_FOR_floatqixf2);
  if (HAVE_ftruncsf2)
    set_optab_handler (ftrunc_optab, SFmode, CODE_FOR_ftruncsf2);
  if (HAVE_ftruncdf2)
    set_optab_handler (ftrunc_optab, DFmode, CODE_FOR_ftruncdf2);
  if (HAVE_ftruncxf2)
    set_optab_handler (ftrunc_optab, XFmode, CODE_FOR_ftruncxf2);
  if (HAVE_fixsfqi2)
    set_convert_optab_handler (sfix_optab, QImode, SFmode, CODE_FOR_fixsfqi2);
  if (HAVE_fixdfqi2)
    set_convert_optab_handler (sfix_optab, QImode, DFmode, CODE_FOR_fixdfqi2);
  if (HAVE_fixxfqi2)
    set_convert_optab_handler (sfix_optab, QImode, XFmode, CODE_FOR_fixxfqi2);
  if (HAVE_fixsfhi2)
    set_convert_optab_handler (sfix_optab, HImode, SFmode, CODE_FOR_fixsfhi2);
  if (HAVE_fixdfhi2)
    set_convert_optab_handler (sfix_optab, HImode, DFmode, CODE_FOR_fixdfhi2);
  if (HAVE_fixxfhi2)
    set_convert_optab_handler (sfix_optab, HImode, XFmode, CODE_FOR_fixxfhi2);
  if (HAVE_fixsfsi2)
    set_convert_optab_handler (sfix_optab, SImode, SFmode, CODE_FOR_fixsfsi2);
  if (HAVE_fixdfsi2)
    set_convert_optab_handler (sfix_optab, SImode, DFmode, CODE_FOR_fixdfsi2);
  if (HAVE_fixxfsi2)
    set_convert_optab_handler (sfix_optab, SImode, XFmode, CODE_FOR_fixxfsi2);
  set_optab_handler (add_optab, SImode, CODE_FOR_addsi3);
  if (HAVE_addsf3)
    set_optab_handler (addv_optab, SFmode, CODE_FOR_addsf3),
    set_optab_handler (add_optab, SFmode, CODE_FOR_addsf3);
  if (HAVE_adddf3)
    set_optab_handler (addv_optab, DFmode, CODE_FOR_adddf3),
    set_optab_handler (add_optab, DFmode, CODE_FOR_adddf3);
  if (HAVE_addxf3)
    set_optab_handler (addv_optab, XFmode, CODE_FOR_addxf3),
    set_optab_handler (add_optab, XFmode, CODE_FOR_addxf3);
  if (HAVE_subsf3)
    set_optab_handler (subv_optab, SFmode, CODE_FOR_subsf3),
    set_optab_handler (sub_optab, SFmode, CODE_FOR_subsf3);
  if (HAVE_subdf3)
    set_optab_handler (subv_optab, DFmode, CODE_FOR_subdf3),
    set_optab_handler (sub_optab, DFmode, CODE_FOR_subdf3);
  if (HAVE_subxf3)
    set_optab_handler (subv_optab, XFmode, CODE_FOR_subxf3),
    set_optab_handler (sub_optab, XFmode, CODE_FOR_subxf3);
  if (HAVE_mulsi3)
    set_optab_handler (smul_optab, SImode, CODE_FOR_mulsi3);
  if (HAVE_umulsidi3)
    set_optab_handler (umul_widen_optab, DImode, CODE_FOR_umulsidi3);
  if (HAVE_mulsidi3)
    set_optab_handler (smul_widen_optab, DImode, CODE_FOR_mulsidi3);
  if (HAVE_umulsi3_highpart)
    set_optab_handler (umul_highpart_optab, SImode, CODE_FOR_umulsi3_highpart);
  if (HAVE_smulsi3_highpart)
    set_optab_handler (smul_highpart_optab, SImode, CODE_FOR_smulsi3_highpart);
  if (HAVE_mulsf3)
    set_optab_handler (smulv_optab, SFmode, CODE_FOR_mulsf3),
    set_optab_handler (smul_optab, SFmode, CODE_FOR_mulsf3);
  if (HAVE_muldf3)
    set_optab_handler (smulv_optab, DFmode, CODE_FOR_muldf3),
    set_optab_handler (smul_optab, DFmode, CODE_FOR_muldf3);
  if (HAVE_mulxf3)
    set_optab_handler (smulv_optab, XFmode, CODE_FOR_mulxf3),
    set_optab_handler (smul_optab, XFmode, CODE_FOR_mulxf3);
  if (HAVE_divsf3)
    set_optab_handler (sdiv_optab, SFmode, CODE_FOR_divsf3);
  if (HAVE_divdf3)
    set_optab_handler (sdiv_optab, DFmode, CODE_FOR_divdf3);
  if (HAVE_divxf3)
    set_optab_handler (sdiv_optab, XFmode, CODE_FOR_divxf3);
  if (HAVE_divmodsi4)
    set_optab_handler (sdivmod_optab, SImode, CODE_FOR_divmodsi4);
  if (HAVE_udivmodsi4)
    set_optab_handler (udivmod_optab, SImode, CODE_FOR_udivmodsi4);
  set_optab_handler (and_optab, SImode, CODE_FOR_andsi3);
  set_optab_handler (ior_optab, SImode, CODE_FOR_iorsi3);
  set_optab_handler (xor_optab, SImode, CODE_FOR_xorsi3);
  set_optab_handler (neg_optab, DImode, CODE_FOR_negdi2);
  set_optab_handler (neg_optab, SImode, CODE_FOR_negsi2);
  set_optab_handler (negv_optab, SFmode, CODE_FOR_negsf2),
    set_optab_handler (neg_optab, SFmode, CODE_FOR_negsf2);
  set_optab_handler (negv_optab, DFmode, CODE_FOR_negdf2),
    set_optab_handler (neg_optab, DFmode, CODE_FOR_negdf2);
  set_optab_handler (negv_optab, XFmode, CODE_FOR_negxf2),
    set_optab_handler (neg_optab, XFmode, CODE_FOR_negxf2);
  if (HAVE_sqrtsf2)
    set_optab_handler (sqrt_optab, SFmode, CODE_FOR_sqrtsf2);
  if (HAVE_sqrtdf2)
    set_optab_handler (sqrt_optab, DFmode, CODE_FOR_sqrtdf2);
  if (HAVE_sqrtxf2)
    set_optab_handler (sqrt_optab, XFmode, CODE_FOR_sqrtxf2);
  set_optab_handler (absv_optab, SFmode, CODE_FOR_abssf2),
    set_optab_handler (abs_optab, SFmode, CODE_FOR_abssf2);
  set_optab_handler (absv_optab, DFmode, CODE_FOR_absdf2),
    set_optab_handler (abs_optab, DFmode, CODE_FOR_absdf2);
  set_optab_handler (absv_optab, XFmode, CODE_FOR_absxf2),
    set_optab_handler (abs_optab, XFmode, CODE_FOR_absxf2);
  set_optab_handler (one_cmpl_optab, SImode, CODE_FOR_one_cmplsi2);
  if (HAVE_ashldi3)
    set_optab_handler (ashl_optab, DImode, CODE_FOR_ashldi3);
  if (HAVE_ashrdi3)
    set_optab_handler (ashr_optab, DImode, CODE_FOR_ashrdi3);
  if (HAVE_lshrdi3)
    set_optab_handler (lshr_optab, DImode, CODE_FOR_lshrdi3);
  if (HAVE_ctrapdi4)
    set_optab_handler (ctrap_optab, DImode, CODE_FOR_ctrapdi4);
  if (HAVE_ctrapsi4)
    set_optab_handler (ctrap_optab, SImode, CODE_FOR_ctrapsi4);
  if (HAVE_ctraphi4)
    set_optab_handler (ctrap_optab, HImode, CODE_FOR_ctraphi4);
  if (HAVE_ctrapqi4)
    set_optab_handler (ctrap_optab, QImode, CODE_FOR_ctrapqi4);

#ifdef FIXUNS_TRUNC_LIKE_FIX_TRUNC
  /* This flag says the same insns that convert to a signed fixnum
     also convert validly to an unsigned one.  */
  for (i = 0; i < NUM_MACHINE_MODES; i++)
    for (j = 0; j < NUM_MACHINE_MODES; j++)
      set_convert_optab_handler
 	(ufixtrunc_optab, (enum machine_mode) i, (enum machine_mode) j,
	 convert_optab_handler (sfixtrunc_optab, (enum machine_mode) i,
						 (enum machine_mode) j));
#endif
}
