/* Generated automatically by the program 'build/genpreds'
   from the machine description file '../../gcc/config/m68k/m68k.md'.  */

#ifndef GCC_TM_CONSTRS_H
#define GCC_TM_CONSTRS_H

static inline bool
satisfies_constraint_I (rtx op)
{
  HOST_WIDE_INT ival = 0;
  if (CONST_INT_P (op))
    ival = INTVAL (op);
  return (GET_CODE (op) == CONST_INT) && (
#line 32 "../../gcc/config/m68k/constraints.md"
(ival > 0 && ival <= 8));
}
static inline bool
satisfies_constraint_J (rtx op)
{
  HOST_WIDE_INT ival = 0;
  if (CONST_INT_P (op))
    ival = INTVAL (op);
  return (GET_CODE (op) == CONST_INT) && (
#line 37 "../../gcc/config/m68k/constraints.md"
(ival >= -0x8000 && ival <= 0x7fff));
}
static inline bool
satisfies_constraint_K (rtx op)
{
  HOST_WIDE_INT ival = 0;
  if (CONST_INT_P (op))
    ival = INTVAL (op);
  return (GET_CODE (op) == CONST_INT) && (
#line 42 "../../gcc/config/m68k/constraints.md"
(ival < -0x80 || ival >= 0x80));
}
static inline bool
satisfies_constraint_L (rtx op)
{
  HOST_WIDE_INT ival = 0;
  if (CONST_INT_P (op))
    ival = INTVAL (op);
  return (GET_CODE (op) == CONST_INT) && (
#line 47 "../../gcc/config/m68k/constraints.md"
(ival < 0 && ival >= -8));
}
static inline bool
satisfies_constraint_M (rtx op)
{
  HOST_WIDE_INT ival = 0;
  if (CONST_INT_P (op))
    ival = INTVAL (op);
  return (GET_CODE (op) == CONST_INT) && (
#line 52 "../../gcc/config/m68k/constraints.md"
(ival < -0x100 || ival >= 0x100));
}
static inline bool
satisfies_constraint_N (rtx op)
{
  HOST_WIDE_INT ival = 0;
  if (CONST_INT_P (op))
    ival = INTVAL (op);
  return (GET_CODE (op) == CONST_INT) && (
#line 57 "../../gcc/config/m68k/constraints.md"
(ival >= 24 && ival <= 31));
}
static inline bool
satisfies_constraint_O (rtx op)
{
  HOST_WIDE_INT ival = 0;
  if (CONST_INT_P (op))
    ival = INTVAL (op);
  return (GET_CODE (op) == CONST_INT) && (
#line 62 "../../gcc/config/m68k/constraints.md"
(ival == 16));
}
static inline bool
satisfies_constraint_P (rtx op)
{
  HOST_WIDE_INT ival = 0;
  if (CONST_INT_P (op))
    ival = INTVAL (op);
  return (GET_CODE (op) == CONST_INT) && (
#line 67 "../../gcc/config/m68k/constraints.md"
(ival >= 8 && ival <= 15));
}
static inline bool
satisfies_constraint_R (rtx op)
{
  HOST_WIDE_INT ival = 0;
  if (CONST_INT_P (op))
    ival = INTVAL (op);
  return (GET_CODE (op) == CONST_INT) && (
#line 72 "../../gcc/config/m68k/constraints.md"
(valid_mov3q_const (ival)));
}
static inline bool
satisfies_constraint_G (rtx op)
{
  return (GET_CODE (op) == CONST_DOUBLE) && (
#line 79 "../../gcc/config/m68k/constraints.md"
(!(TARGET_68881 && standard_68881_constant_p (op))));
}
static inline bool
satisfies_constraint_H (rtx op)
{
  return (GET_CODE (op) == CONST_DOUBLE) && (
#line 84 "../../gcc/config/m68k/constraints.md"
(op == CONST0_RTX (GET_MODE (op))));
}
static inline bool
satisfies_constraint_S (rtx op)
{
  return (GET_CODE (op) == MEM) && (
#line 89 "../../gcc/config/m68k/constraints.md"
(TARGET_PCREL
		    && (GET_CODE (XEXP (op, 0)) == SYMBOL_REF
			|| GET_CODE (XEXP (op, 0)) == LABEL_REF
			|| GET_CODE (XEXP (op, 0)) == CONST)));
}
static inline bool
satisfies_constraint_T (rtx op)
{
  switch (GET_CODE (op))
    {
    case SYMBOL_REF:
    case LABEL_REF:
    case CONST:
      break;
    default:
      return false;
    }
  return 
#line 97 "../../gcc/config/m68k/constraints.md"
(!flag_pic);
}
static inline bool
satisfies_constraint_Q (rtx op)
{
  return (GET_CODE (op) == MEM) && (
#line 102 "../../gcc/config/m68k/constraints.md"
(m68k_matches_q_p (op)));
}
static inline bool
satisfies_constraint_U (rtx op)
{
  return (GET_CODE (op) == MEM) && (
#line 107 "../../gcc/config/m68k/constraints.md"
(m68k_matches_u_p (op)));
}
static inline bool
satisfies_constraint_W (rtx op)
{
  enum machine_mode mode = GET_MODE (op);
  return const_call_operand (op, mode);
}
static inline bool
satisfies_constraint_Cs (rtx op)
{
  switch (GET_CODE (op))
    {
    case SYMBOL_REF:
    case CONST:
      return true;
    default:
      break;
    }
  return false;
}
static inline bool
satisfies_constraint_Ci (rtx op)
{
  return (GET_CODE (op) == CONST_INT) && (
#line 120 "../../gcc/config/m68k/constraints.md"
(true));
}
static inline bool
satisfies_constraint_C0 (rtx op)
{
  HOST_WIDE_INT ival = 0;
  if (CONST_INT_P (op))
    ival = INTVAL (op);
  return (GET_CODE (op) == CONST_INT) && (
#line 125 "../../gcc/config/m68k/constraints.md"
(ival == 0));
}
static inline bool
satisfies_constraint_Cj (rtx op)
{
  HOST_WIDE_INT ival = 0;
  if (CONST_INT_P (op))
    ival = INTVAL (op);
  return (GET_CODE (op) == CONST_INT) && (
#line 130 "../../gcc/config/m68k/constraints.md"
(ival < -0x8000 || ival > 0x7FFF));
}
static inline bool
satisfies_constraint_Cu (rtx op)
{
  return (GET_CODE (op) == CONST) && (
#line 135 "../../gcc/config/m68k/constraints.md"
(m68k_unwrap_symbol (op, false) != op));
}
static inline bool
satisfies_constraint_CQ (rtx op)
{
  HOST_WIDE_INT ival = 0;
  if (CONST_INT_P (op))
    ival = INTVAL (op);
  return (GET_CODE (op) == CONST_INT) && (
#line 140 "../../gcc/config/m68k/constraints.md"
(m68k_const_method (ival) == MOVQ));
}
static inline bool
satisfies_constraint_CW (rtx op)
{
  HOST_WIDE_INT ival = 0;
  if (CONST_INT_P (op))
    ival = INTVAL (op);
  return (GET_CODE (op) == CONST_INT) && (
#line 145 "../../gcc/config/m68k/constraints.md"
(m68k_const_method (ival) == SWAP));
}
static inline bool
satisfies_constraint_CZ (rtx op)
{
  HOST_WIDE_INT ival = 0;
  if (CONST_INT_P (op))
    ival = INTVAL (op);
  return (GET_CODE (op) == CONST_INT) && (
#line 150 "../../gcc/config/m68k/constraints.md"
(m68k_const_method (ival) == MVZ));
}
static inline bool
satisfies_constraint_CS (rtx op)
{
  HOST_WIDE_INT ival = 0;
  if (CONST_INT_P (op))
    ival = INTVAL (op);
  return (GET_CODE (op) == CONST_INT) && (
#line 155 "../../gcc/config/m68k/constraints.md"
(m68k_const_method (ival) == MVS));
}
static inline bool
satisfies_constraint_Ap (rtx op)
{
  enum machine_mode mode = GET_MODE (op);
  return push_operand (op, mode);
}
static inline bool
satisfies_constraint_Ac (rtx op)
{
  enum machine_mode mode = GET_MODE (op);
  return (movsi_const0_operand (op, mode)) && (
#line 164 "../../gcc/config/m68k/constraints.md"
(!REG_P (op)));
}
#endif /* tm-constrs.h */
